<?php

/*
 * ******************************************************************************
 * File name: class.receipt.php
 * Created on: 02/07/2008
 * ******************************************************************************
  -----------------
  -- Description --
  -----------------
  This file contains the class for receipt module.

  -----------------------------------------
  -- Major Revision/Modification History --
  -----------------------------------------
  Date     Programmer      Comments
  -------- --------------- ------------------------------------------------------
  07/07/2008	Anish Sharma	Started building the file.

 * ******************************************************************************
 *  Written By: Anish Sharma.
 * ******************************************************************************
 */

class clientprofile {

	var $rNo = '';
	var $raNo = '';
	var $cntType = '';
	var $stid = '';
	var $cid = '';
	var $fName = '';
	var $mName = '';
	var $lName = '';
	var $address = '';
	var $town = '';
	var $state = '';
	var $zip = '';
	var $country = '';
	var $resi = '';
	var $office = '';
	var $mob = '';
	var $email = '';
	var $instName = '';
	var $pPlan = '';
	var $payAmt = '';
	var $discount = '';
	var $amtPayable = '';
	var $amtPaidOnDate = '';
	var $amtBalance = '';
	var $pMode = '';
	var $chqDD = '';
	var $chqDDdate = '';
	var $bank = '';
	var $remarks = '';
	var $advisor = '';
	var $refund = '';
	var $clId = '';
	var $currId = '';
	var $con;
	var $home1;
	var $t;
	var $action;
	var $isDuplicateClient = 0;
	var $duplicateClId;
	var $pageName = 'clientprofile.php';

	/**
	 * This function will act as constructor.
	 * @param	string tplPath template path.
	 * @param	string maintpl main tpl file name.
	 * @param	string outerCenter outer center tpl file name.
	 * @param	string innerCenter inner tpl file name.
	 * @param	string headtpl header tpl file name.
	 * @param	string lefttpl left tpl file name.
	 * @param	string righttpl right tpl file name.
	 * @param	string footertpl footer tpl file name.
	 * @author	Anish Sharma
	 */
	function __construct($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl) {
		$this->home1 = new Home($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl);
		$this->home1->InitializeTemplates();
		$this->con = $this->home1->con;
		$this->action = (isset($_GET['action']) ? $_GET['action'] : '');
		$this->clId = ((isset($_GET['clId']) ? $_GET['clId'] : '0'));
		$this->clId = ((isset($_POST['clId']) ? $_POST['clId'] : $this->clId));
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				$this->{$key} = $value;
			}
		}
	}

	/**
	 * This function will main function used to asign template
	 * variable and call other functions.
	 * @author	Anish Sharma
	 */
	function create() {
		$this->t = &$this->home1->t;
		$this->parseBody();
		$this->home1->showInPage();
	}

	function assignPostValues() {
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				$this->t->set_var($key, $value);
			}
		}
	}

	/**
	 * This function will parse the body after creating it.
	 * @author	Anish Sharma
	 */
	function parseBody() {
		global $_CONF, $siteUrl, $siteUrlAjax;
		$this->t->set_block("FORMPAGE", "payDetails", "payDetail");
		$this->t->set_block("FORMPAGE", "remarks", "remark");

		$this->t->set_block("FORMPAGE", "refundIn", "refundin");
		$this->t->set_block("FORMPAGE", "refundNo", "refundno");

		if (isset($_GET['clId']) && $_GET['clId'] != '') {
			$url = array();
			foreach ($_GET as $k => $v) {
				$url[] = $_GET['' . "{$k}" . ''];
			}
			$this->getClientProfile($url);
		}
		if (isset($_SESSION['msg'])) {
			$this->t->set_var('msg', $_SESSION['msg']);
			unset($_SESSION['msg']);
		}
		$this->t->parse('TPL_BODY', 'FORMPAGE');
	}

	function getClientProfile($id) {
		global $siteUrl;
		$condition = '';
		$status = '';
		$OrgNo = '';
		$rNo = '';
		switch ($id[5]) {
			case 'Old':
				$what = " clOldRetainerAggNo ";
				break;
			case 'New':
				$what = " clRetainerAggNo ";
				break;
		}
		$sql = "SELECT *, DATE_FORMAT(clCreateDate,'%y') AS cdated, DATE_FORMAT(clCreateDate,'%d-%m-%Y')  AS dated, DATE_FORMAT(clCaseDate,'%d-%m-%Y')  AS clCaseDate, DATE_FORMAT(pdDate,'%d-%m-%Y')  AS pdDate, DATE_FORMAT(pdRefundDate,'%d-%m-%Y')  AS pdRefundDate, totalSum FROM tbl_client TC LEFT OUTER JOIN tbl_paydetails PD ON (TC.clId=PD.pdClID) LEFT JOIN ( SELECT clServCountryId, SUM(pdPaid) AS totalSum FROM tbl_client TCIN LEFT OUTER JOIN tbl_paydetails TPIN ON (clId=pdClId) WHERE {$what} LIKE '{$id[0]}' AND clReceiptIssuingBranchId=$id[1] AND clCtTypeId = $id[2] AND clServTypeId = $id[3] AND clServCountryId = $id[4] GROUP BY clServCountryId) gId ON TC.clServCountryId=gId.clServCountryId WHERE {$what} LIKE '{$id[0]}' AND clReceiptIssuingBranchId=$id[1] AND clCtTypeId = $id[2] AND clServTypeId = $id[3] AND TC.clServCountryId = $id[4] ORDER BY clCreateDate ASC";
		$result = $this->con->execQry($sql);
		if ($this->con->rowCount($result)) {
			$i = 1;
			while ($rowObj = $this->con->fetchObj($result)) {
				if ($rowObj->clRetainerAggNo == 0) {
					$raNo = $rowObj->clOldRetainerAggNo;
					$tdOldTop = '<td width="85" align="center" class="border2">Old Payment Paid,<br>Old Discont</td>';
					$tdOldBottom = '<td width="85" align="center" class="border2">' . ($rowObj->pdPaidOld != '' ? $rowObj->pdPaidOld : 'none') . ',<br>' . ($rowObj->pdDiscountOld != '' ? $rowObj->pdDiscountOld : 'none') . '</td>';
					$colSpan = '4';
				} else {
					$prefixRaCode =
						getPreCodeForRaNo($rowObj->clServTypeId, $id[1], $rowObj->clServCountryId) . getMonYrForRa($rowObj->clRetainerAggNo, $rowObj->clReceiptIssuingBranchId, $rowObj->clEmail);
					$raNo = $prefixRaCode . str_pad($rowObj->clRetainerAggNo, 4, "0", STR_PAD_LEFT);
					$tdOldTop = '';
					$tdOldBottom = '';
					$colSpan = '3';
				}

				$dated = $rowObj->dated;
				$branch = getBranchName($id[1]);

				$fName = html_entities($rowObj->clFirstName);
				$mName = ($rowObj->clMiddleName ? html_entities($rowObj->clMiddleName) : '');
				$lName = html_entities($rowObj->clLastName);
				$clName = $fName . '&nbsp;' . $mName . '&nbsp;' . $lName;

				$clAddr = html_entities($rowObj->clAddr);
				$clCity = html_entities($rowObj->clCity);
				$clState = (is_numeric($rowObj->clState)) ? getStateName($rowObj->clState) : $rowObj->clState;
				$clZip = html_entities($rowObj->clZipCode);
				$clEmail = $rowObj->clEmail;

				$clPh = ($rowObj->clPhRes ? $rowObj->clPhRes . '(R),&nbsp;' : '') . ($rowObj->clPhWork ? $rowObj->clPhWork . '(O),&nbsp;' : '') . ($rowObj->clPhMob ? $rowObj->clPhMob . '(M)&nbsp;' : '');

				$ctId = getConsultancyName($rowObj->clCtTypeId);

				$clSt = getServiceTypeName($rowObj->clServTypeId);
				$clServCountryId = getCountryName($rowObj->clServCountryId);
				$clCountry = getCountryName($rowObj->clCountryId);
				if ($rowObj->pdPid != 0) {
					$pPlan = '<tr>
							<td height="22" width="220" class="padleft_10"><b><span class="float-left">Payment Plan Chosen</span><span class="float-right marginright_25">:</span></b></td>
							<td width="670">' . getPayPlanName($rowObj->pdPid) . '</td>
						</tr>';
				} else {
					$pPlan = '';
				}
				$instName = getInstallmentName($rowObj->pdInstNameId);
				$rDated = $rowObj->dated;
				$prefixCode = getStateCode($id[1]);
				if ($rowObj->clFullReceiptNo != '') {
					//$rNo   = $prefixCode.$rowObj->cdated.str_pad($rowObj->clReceiptNo, 3, "0", STR_PAD_LEFT); [COMMENTED ON 5th MAY 2010]
					$rNo = $rowObj->clFullReceiptNo;
				} else {
					$rNo = $prefixCode . $rowObj->cdated . str_pad($rowObj->clReceiptNo, 3, "0", STR_PAD_LEFT); // [ADDED ON 5th MAY 2010]
				}
				$curr = explode(',', getCurrCode($id[8]));

				if ($rowObj->pdPid != 0) {
					$pAmt = getPayPlanAmt($rowObj->pdPid, '0');
				} else {
					$pAmt = $rowObj->pdAmt;
				}

				$pDiscount = ($rowObj->pdDiscount != '') ? $curr[0] . '&nbsp;' . $rowObj->pdDiscount : 'nil';

				$amtPayable = $curr[0] . '&nbsp;' . $rowObj->pdTotalPayable;
				$amtPaid = $curr[0] . '&nbsp;' . $rowObj->pdPaid;
				$pMode = getPayMode($rowObj->pdPayModeId);
				$chqDetails = ($rowObj->pdChqDDno != '') ? $rowObj->pdChqDDbank . '&nbsp;/&nbsp;' . $rowObj->pdChqDDdate . '&nbsp;/&nbsp;' . $rowObj->pdChqDDno : 'NA';
				$balAmt = $curr[0] . '&nbsp;' . $rowObj->pdBalance;

				if ($rowObj->pdAdvisorId != 0) {
					$advName = '<tr><td height="22"  width="220" class="padleft_10"><b><span class="float-left">Advisor Name</span><span class="float-right marginright_25">:</span></b></td><td width="670">&nbsp;' . getAdvisorName($rowObj->pdAdvisorId) . '</td></tr>';
				} else {
					$advName = '';
				}

				$status = getCaseStatusName($rowObj->clCaseStatus);
				if ($status == 'Receipt Cancelled') {
					$status = '<font color="red"><b>PROFILE CANCELLED</b></font>';
				}
				$statusOn = ($rowObj->clCaseStatus != 0 ? '&nbsp;<b>ON</b>&nbsp;' . $rowObj->clCaseDate . '' : '');

				if ($rowObj->clCaseStatus == 2) {
					$tdCancelled = '<img src="images/cancelled_stamp.jpg">';
				} else {
					$tdCancelled = '';
				}

				$this->t->set_var('installment', $instName);
				$this->t->set_var('instNo', $rowObj->clInstNo);
				$this->t->set_var('tdCancelled', $tdCancelled);
				$this->t->set_var('rNo', $rNo);
				$this->t->set_var('rDated', $rDated);

				$this->t->set_var('remarkDate', $rDated);
				$this->t->set_var('remarkName', getBranchManagerName($rowObj->clReceiptIssuingBranchId));
				$this->t->set_var('issuerRemarks', ($rowObj->pdIssuerRemark != '') ? html_entities($rowObj->pdIssuerRemark) : '-');

				$this->t->set_var('pAmt', $pAmt);
				$this->t->set_var('discount', $pDiscount);
				$this->t->set_var('amtPayable', $amtPayable);
				$this->t->set_var('amtPaid', $amtPaid);
				$this->t->set_var('pMode', $pMode);
				$this->t->set_var('chqDetails', $chqDetails);
				$this->t->set_var('balAmt', $balAmt);
				$this->t->set_var('tdOldTop', $tdOldTop);
				$this->t->set_var('tdOldBottom', $tdOldBottom);

				$this->t->parse("payDetail", "payDetails", true);
				$this->t->parse("remark", "remarks", true);

				if ($rowObj->pdRefundRemarks != '') {
					$refundDate = $rowObj->pdRefundDate;
					$refundAmt = ($rowObj->pdRefundAmt != '' ? $curr[0] . '&nbsp;' . $rowObj->pdRefundAmt : '--');
					$refundApprovedBy = ($rowObj->pdRefundApprovBy != '' ? $rowObj->pdRefundApprovBy : '--');
					$refundRemarks = html_entities($rowObj->pdRefundRemarks);

					$this->t->set_var('refundDate', $refundDate);
					$this->t->set_var('refundAmt', $refundAmt);
					$this->t->set_var('refundApprovedBy', $refundApprovedBy);
					$this->t->set_var('refundRemarks', $refundRemarks);

					$this->t->parse("refundin", "refundIn");
					$this->t->parse("refundNo", "");
				}
				$total = $curr[0] . '&nbsp;' . $rowObj->totalSum;
				$i++;
			}


			$this->t->set_var('advName', $advName);
			$this->t->set_var('status', $status);
			$this->t->set_var('statusOn', $statusOn);
			$this->t->set_var('total', $total);
			$this->t->set_var('balTotal', $balAmt);
			$this->t->set_var('raNo', $raNo);
			$this->t->set_var('dated', $dated);
			$this->t->set_var('colSpan', $colSpan);
			$this->t->set_var('branch', $branch);
			$this->t->set_var('name', $clName);
			$this->t->set_var('address', $clAddr);
			$this->t->set_var('city', $clCity);
			$this->t->set_var('state', $clState);
			$this->t->set_var('zip', $clZip);
			$this->t->set_var('email', $clEmail);
			$this->t->set_var('phone', $clPh);
			$this->t->set_var('cntType', $ctId);
			$this->t->set_var('country', $clCountry);
			$this->t->set_var('servCnt', $clServCountryId);
			$this->t->set_var('servType', $clSt);
			$this->t->set_var('pPlan', $pPlan);
		}
	}

}

?>
