<?php
// ini_set("display_error",true);
ini_set("max_execution_time",120);
ini_set('memory_limit', '2048M');
/*
 * ******************************************************************************
 * File name: class.generatereport.php
 * Created on: 02/07/2008
 * ******************************************************************************
  -----------------
  -- Description --
  -----------------
  This file contains the class for generatereport module.

  -----------------------------------------
  -- Major Revision/Modification History --
  -----------------------------------------
  Date     Programmer      Comments
  -------- --------------- ------------------------------------------------------
  07/07/2008	Anish Sharma	Started building the file.

 * ******************************************************************************
 *  Written By: Anish Sharma.
 * ******************************************************************************
 */

class generatereport {

	var $con;
	var $home1;
	var $t;
	var $action;
	var $isDuplicateClient = 0;
	var $duplicateClId;
	var $pageName = 'generatereport.php';
	var $cntType = '';
	var $srvType = '';
	var $srvCnt = '';
	var $branch = '';
	var $csStatus = '';
	var $pMode = '';
	var $adv = '';
	var $instName = '';
	var $payPlan = '';
	var $fromDate = '';
	var $toDate = '';

	/**
	 * This function will act as constructor.
	 * @param	string tplPath template path.
	 * @param	string maintpl main tpl file name.
	 * @param	string outerCenter outer center tpl file name.
	 * @param	string innerCenter inner tpl file name.
	 * @param	string headtpl header tpl file name.
	 * @param	string lefttpl left tpl file name.
	 * @param	string righttpl right tpl file name.
	 * @param	string footertpl footer tpl file name.
	 * @author	Anish Sharma
	 */
	function __construct($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl) {
		$this->home1 = new Home($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl);
		$this->home1->InitializeTemplates();
		$this->con = $this->home1->con;
		$this->action = (isset($_GET['action']) ? $_GET['action'] : '');
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				$this->{$key} = $value;
			}
		}
	}

	/**
	 * This function will main function used to asign template
	 * variable and call other functions.
	 * @author	Anish Sharma
	 */
	function create() {
		$this->t = &$this->home1->t;
		$this->parseBody();
		$this->home1->showInPage();
	}

	function assignPostValues() {
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				return $this->t->set_var($key, $value);
			}
		}
	}

	/**
	 * This function will parse the body after creating it.
	 * @author	Anish Sharma
	 */
	function parseBody() {
		global $_CONF, $siteUrl, $siteUrlAjax;
		$this->t->set_block("FORMPAGE", "records", "record");
		$this->t->set_block("FORMPAGE", "norecords", "norecord");
		$this->t->set_block("FORMPAGE", "recordsMain", "recordMain");

		if (isset($_POST['subm']) && $_POST['subm'] == '1') {
			$this->genReport($_POST);
			$this->t->set_var('disp', "style='display:absolute;'");
		} else {
			$this->t->set_var('disp', "style='display:none;'");
		}
		if (isset($_SESSION['msg'])) {
			$this->t->set_var('msg', $_SESSION['msg']);
			unset($_SESSION['msg']);
		}

		$currName = explode(',', getCurrCode($_SESSION['session_countryId']));

		$cntType = (isset($_POST['subm']) ? $this->cntType : '');
		$this->t->set_var('consultancyType', counsultancyTypeList($cntType));

		$this->t->set_var('ajaxSiteUrl', $siteUrlAjax);
		$this->t->set_var('branchId', $_SESSION['session_userId']);
		$this->t->set_var('currName', $currName[0]);
		$this->t->set_var('currId', $currName[1]);
		$this->t->set_var('menu', getMenuLinks($_SESSION['session_usertype']));

		$srvType = (isset($_POST['subm']) ? $this->srvType : '');
		$this->t->set_var('serviceType', serviceTypeList($srvType));

		$csStatus = (isset($_POST['subm']) ? $this->csStatus : '');
		$caseStatus = (($csStatus == 0) && ($csStatus != '') ? caseStatusList($csStatus, 1) : caseStatusList($csStatus));
		$this->t->set_var('caseStatus', $caseStatus);

		$sr = ((isset($_POST['subm']) && isset($_POST['branch'])) ? $this->branch : $_SESSION['session_userId']);
         
		if ($_SESSION['session_usertype'] == 2) {
			$htmlStart = '';
			$htmlEnd = '';
			$this->t->set_var('htmlStart', $htmlStart);
			//$this->t->set_var('usrBrId',$usrBrId);
			$this->t->set_var('branch', firstUpper($_SESSION['session_userName']));
			$this->t->set_var('htmlEnd', $htmlEnd);
		} else {			
		$htmlStart = '<select name="branch" id="branch" class="form_field_text" onchange="advisorListByBranch();"><option value="">-Select Branch-</option>';       //    $htmlStart = '<select name="branch" id="branch" class="form_field_text" onchange="advisorListByBranch();"><option value="">-Select Branch-</option>';
			$htmlEnd = '</select>';
			//$usrBrId = '';
			//$this->t->set_var('usrBrId',$usrBrId);
			$this->t->set_var('htmlStart', $htmlStart);
			$this->t->set_var('branch', branchListByLogin($_SESSION['session_userId'], $sr, 0));
			$this->t->set_var('htmlEnd', $htmlEnd);
		}

		$srAdv = (isset($_POST['subm']) ? $this->adv : '');
		$this->t->set_var('advisor', advisorListByLogin($_SESSION['session_userId'], $srAdv));

		$srPayPlan = (isset($_POST['subm']) ? $this->payPlan : '');
		$this->t->set_var('pPlan', pPlanByLogin($_SESSION['session_userId'], $srPayPlan));

		$srSc = (isset($_POST['subm']) ? $this->srvCnt : '');
		$this->t->set_var('serviceCountry', serviceCountry($srSc));

		$pMode = (isset($_POST['subm']) ? $this->pMode : '');
		$this->t->set_var('pMode', paymentModeList($pMode));

		$fDate = ((isset($_POST['subm']) && $_POST['fromDate'] != '') ? $this->fromDate : '');
		$this->t->set_var('fDate', $fDate);

		$tDate = ((isset($_POST['subm']) && $_POST['toDate'] != '') ? $this->toDate : '');
		$this->t->set_var('tDate', $tDate);

		$installmentNo = '';
		$i = '';
		for ($i = 1; $i <= 6; $i++) {
			$selInstNo = ((isset($_POST['subm']) && $_POST['instName'] == $i) ? 'selected' : '');
			$installmentNo .= "<option value='{$i}' {$selInstNo}>{$i}</option>";
		}
		$this->t->set_var('installmentNo', $installmentNo);

		$this->t->parse('TPL_BODY', 'FORMPAGE');
	}

	function genReport($data) {
		global $siteUrl;
		$condition = '';
		$status = '';
		$OrgNo = '';
		$rNo = '';
		$qry = '';
		$search = array();
		$totalBalance = '';
		$totalPaid = '';
		//print_r($_POST);
		if ($_POST['fromDate'] != '') {
			$search[] = " CAST(TC.clCreateDate AS DATE) >= '" . $this->fromDate . "'";
		}

		if ($_POST['toDate']) {
			$search[] = " CAST(TC.clCreateDate AS DATE) <= '" . $this->toDate . "'";
		}

		if ($_POST['cntType'] != '') {
			$search[] = ' clCtTypeId =' . $this->cntType;
		}

		if ($_POST['srvType']) {
			$search[] = ' clServTypeId=' . $this->srvType;
		}

		if ($_POST['srvCnt'] != '') {
			$search[] = ' clServCountryId=' . $this->srvCnt;
		}

		if (isset($_POST['branch']) && $_POST['branch'] == 'all') {
			$qry = 1;
			//$search[] ='';
		} else if (isset($_POST['branch']) && $_POST['branch'] != 'all') {
			$search[] = ' clReceiptIssuingBranchId=' . $this->branch;
		} else {
			$search[] = ' clReceiptIssuingBranchId=' . $_SESSION['session_userId'];
		}

		if ($_POST['pMode'] != '') {
			$search[] = ' pdPayModeId=' . $this->pMode;
		}

		if ($_POST['adv'] != '') {
			$search[] = ' pdAdvisorId=' . $this->adv;
		}

		if ($_POST['payPlan'] != '') {
			$search[] = ' pdPid=' . $this->payPlan;
		}

		if ($_POST['csStatus'] != '') {
			$search[] = ' clCaseStatus=' . $this->csStatus;
		}

		if ($_POST['instName'] != '') {
			$search[] = ' clInstNo=' . $this->instName;
		}

		if (($_POST['adv'] != '') && ($_POST['instName'] == '') && ($_POST['csStatus'] == '') && ($_POST['payPlan'] == '') && ($_POST['pMode'] == '') && ($_POST['srvCnt'] == '') && ($_POST['srvType'] == '') && ($_POST['cntType'] == '')) {
			$search[] = ' pdAdvisorId=' . $this->adv . ' AND clInstNo=1';
		}

		$sr = implode(' AND', $search);
		if ($qry != 1) {
			//$sqlSearch = "SELECT *, DATE_FORMAT(clCreateDate,'%d-%m-%Y') AS dated FROM ".TABLECLIENT." TC LEFT JOIN ".TABLEPAYDETAILS." TPD ON TC.clId=TPD.pdClId LEFT JOIN ".TABLEBRANCH." TB ON TC.clReceiptIssuingBranchId=TB.bId WHERE ".$sr." ORDER BY TB.bScode, dated ASC";
			//[commented the above part on 4th May 09, to display the report properly and added the following code as per the requirement]

			$sqlSearch = "SELECT *, DATE_FORMAT(clCreateDate,'%Y-%m-%d') AS dated, DATE_FORMAT(clCreateDate,'%y') AS cdated  FROM " . TABLECLIENT . " TC LEFT JOIN " . TABLEPAYDETAILS . " TPD ON TC.clId=TPD.pdClId LEFT JOIN " . TABLEBRANCH . " TB ON TC.clReceiptIssuingBranchId=TB.bId WHERE " . $sr;
		} else {
			//$sqlSearch = " SELECT * , DATE_FORMAT( clCreateDate, '%d-%m-%Y' ) AS dated FROM ".TABLEBRANCH." TB LEFT JOIN ".TABLECLIENT." TC ON TC.clReceiptIssuingBranchId = TB.bId LEFT JOIN ".TABLEPAYDETAILS." TPD ON TC.clId = TPD.pdClId  ".(strlen($sr) ? " WHERE ".$sr:'')." ORDER BY TB.bScode, dated ASC";
			//[commented the above part on 4th May 09, to display the report properly and added the following code as per the requirement]

			$sqlSearch = " SELECT * , DATE_FORMAT( clCreateDate, '%d-%m-%Y' ) AS dated, DATE_FORMAT(clCreateDate,'%y') AS cdated FROM " . TABLEBRANCH . " TB LEFT JOIN " . TABLECLIENT . " TC ON TC.clReceiptIssuingBranchId = TB.bId LEFT JOIN " . TABLEPAYDETAILS . " TPD ON TC.clId = TPD.pdClId  " . (strlen($sr) ? " WHERE " . $sr : '') . " ";
		}
		//echo $sr;
		//echo $sqlSearch;
		//die;
		$resSearch = $this->con->execQry($sqlSearch);
		$numOfRows = $this->con->rowCount($resSearch);

		if ($numOfRows != 0) {
			$this->t->set_var('disp', "style='display:absolute;'");
			$i = 1;
			$oldCityId = '';
			$arrBalance = array();
			while ($rowObj = $this->con->fetchObj($resSearch)) {
				if ($rowObj->clEmail != NULL) {
					$this->t->set_var("result", '<label class="pinkbox"><b>' . $i . ' Record(s) Found</b></label>');

					if ($rowObj->bId !== $oldCityId) {
						$this->t->set_var('cityRow', '<tr><td colspan="15">&nbsp;</td></tr><tr bgcolor="#09619A"><td colspan="14" class="border2" align="center"><label class="maroonbox"><b>' . firstUpper($rowObj->bName) . '</b></label></td></tr>');
					} else {
						$this->t->set_var('cityRow', '');
					}
					$oldCityId = $rowObj->bId;
					if ($rowObj->clRetainerAggNo == 0) {
						$linkRaNo = $rowObj->clOldRetainerAggNo;
						$raNo = $rowObj->clOldRetainerAggNo;
						$clType = 'Old';
					} else {
						$prefixRaCode = getPreCodeForRaNo($rowObj->clServTypeId, $rowObj->clReceiptIssuingBranchId, $rowObj->clServCountryId) . getMonYrForRa($rowObj->clRetainerAggNo, $rowObj->clReceiptIssuingBranchId, $rowObj->clEmail);
						$raNo = $prefixRaCode . str_pad($rowObj->clRetainerAggNo, 4, "0", STR_PAD_LEFT);
						$linkRaNo = $rowObj->clRetainerAggNo;
						$clType = 'New';
					}

					$dated = $rowObj->dated;
					$branch = getBranchName($rowObj->clReceiptIssuingBranchId);

					$split = explode(',', getPreCodeForRno($rowObj->clReceiptIssuingBranchId));
					//$rNo   = $split[0].$rowObj->cdated.str_pad($rowObj->clReceiptNo, 3, "0", STR_PAD_LEFT);
					if ($rowObj->clFullReceiptNo != '') {
						$rNo = $rowObj->clFullReceiptNo;
					} else {
						$rNo = $split[0] . $rowObj->cdated . str_pad($rowObj->clReceiptNo, 3, "0", STR_PAD_LEFT); // [ADDED ON 5th MAY 2010]
					}
					//$rNo   = $rowObj->clFullReceiptNo;
					$rNoD = $rowObj->clId;

					$fName = $rowObj->clFirstName;
					$mName = ($rowObj->clMiddleName ? $rowObj->clMiddleName : '');
					$lName = $rowObj->clLastName;
					$clName = $fName . ' ' . $mName . ' ' . $lName;

					$servType = getServiceTypeName($rowObj->clServTypeId);
					if ($servType == 'Immigration') {
						$sType = 'IMMI';
						$color = '#FE6602';
					} else {
						$sType = 'SA';
						$color = '#00923F';
					}
					$scName = getCountryName($rowObj->clServCountryId);

					$iName = getInstallmentName($rowObj->pdInstNameId);

					$pName = getPayPlanName($rowObj->pdPid);

					if ($rowObj->pdPid != 0) {
						$pAmt = getPayPlanAmt($rowObj->pdPid, 1);
					} else {
						$pAmt = $rowObj->pdAmt;
					}
					$currName = explode(',', getCurrCode($split[1]));

					//for shwowing the discount in current reciept
					//$discount = ($rowObj->pdDiscount != '') ? $rowObj->pdDiscount : '0';
					//Change Request: For showing all the pasts Discounts
					$discount =getCompletePastDiscounts($linkRaNo,$rowObj->clReceiptIssuingBranchId,$rowObj->clCtTypeId,$rowObj->clServTypeId,$rowObj->clServCountryId);

					$amtPaid = ($rowObj->pdPaid != '') ? $rowObj->pdPaid : '0';

					$balance = ($rowObj->pdBalance != '') ? $rowObj->pdBalance : '0';

					$mode = getPayMode($rowObj->pdPayModeId);

					$csStatus = getCaseStatusName($rowObj->clCaseStatus);
					/* if($rowObj->clCaseStatus!=2){
					  $rNoLink = '<a href="printout.php?clId='.$rNoD.'" class="dispLinkM" target="_blank" title="view the receipt">'.$rNo.'</a>';
					  } else {
					  $rNoLink = $rNo;
					  } */
					
					//echo "<pre>";print_r($rowObj->clCreateDate);
					
					
					$createdate=substr($rowObj->clCreateDate,0,10);
					
				if($createdate>='2024-02-01')   
				 	{
					$rNoLink = '<a href="printout_gst.php?clId=' . $rNoD . '" class="dispLinkM" target="_blank" title="view the receipt">' . $rNo . '</a>';
				}
				 	else
				 	{
				 	    	$rNoLink = '<a href="printout.php?clId=' . $rNoD . '" class="dispLinkM" target="_blank" title="view the receipt">' . $rNo . '</a>';
				 	}
				
				
				// 	if($createdate>='2017-02-01')
				// 	//if($createdate=='2017-05-01')   
				// 	{
				// 		$rNoLink = '<a href="printout_gst.php?clId=' . $rNoD . '" class="dispLinkM" target="_blank" title="view the receipt">' . $rNo . '</a>';
				// 		//echo 'greater than';
				// 		//die;
				// 	}
				// 	else
				// 	{
				// 		$rNoLink = '<a href="printout.php?clId=' . $rNoD . '" class="dispLinkM" target="_blank" title="view the receipt">' . $rNo . '</a>';
				// 		//echo 'Less than';
				// 	}
					
					
					
					//$rNoLink = '<a href="printout.php?clId=' . $rNoD . '" class="dispLinkM" target="_blank" title="view the receipt">' . $rNo . '</a>';
					switch ($rowObj->clCaseStatus) {
						case 0: // in progress
							$classCaseStatus = 'class="inProgress"';
							break;
						case 1: // case abondoned
							$classCaseStatus = 'class="csAbondoned"';
							break;
						case 2: // receipt cancelled
							$classCaseStatus = 'class="rcptCancelled"';
							break;
						case 3: // ccVg
							$classCaseStatus = 'class="ccVg"';
							break;
						case 4: // ccVr
							$classCaseStatus = 'class="ccVr"';
							break;
						case 5: // refund
							$classCaseStatus = 'class="refund"';
							break;
					}

					//$remarks = ($rowObj->pdIssuerRemark!='')?$rowObj->pdIssuerRemark:'none';

					if ($rowObj->pdIssuerRemark != '') {
						$htmlRemark = '<a href="remarks.php?rm=' . $rowObj->clId . '&height=300&width=400" title="Remarks" class="thickbox dispLinkM">View</a>';
					} else {
						$htmlRemark = 'No Remarks';
					}
//echo print_r($_SESSION);die;

					$htmlEdit = '<a href="editrec.php?clId=' . $rNoD . '" class="dispLinkM" target="_blank">Edit</a>';
					if ($rowObj->clCaseStatus != 2 && $rowObj->clCaseStatus != 5) {
						$totalPaid = $totalPaid + $rowObj->pdPaid;
					}
if($_SESSION['session_userId']==6){
					$this->t->set_var('editField', '<td align="center" class="border2">Edit</td>');
					$this->t->set_var('editLink', '<td class="border2">'.$htmlEdit.'</td>');
}

					$arrBalance[$linkRaNo][$clType][$rowObj->clCtTypeId][$rowObj->clServCountryId][$rowObj->clServTypeId][$rowObj->clReceiptIssuingBranchId] = $rowObj->clReceiptNo;
					$expDate = explode('-', $dated);


					$this->t->set_var('i', $i);
					//$this->t->set_var('rNo',$rNo);
					//$this->t->set_var('rNoD',$rNoD);

					$this->t->set_var('rNoLink', $rNoLink);
					$this->t->set_var('crNo', $rowObj->clReceiptNo);
					$this->t->set_var('raNo', $raNo);
					$this->t->set_var('dated', $dated);
					$this->t->set_var('cm', $expDate[1]);
					$this->t->set_var('cy', $expDate[0]);
					$this->t->set_var('iNo', ($rowObj->clRetainerAggNo != 0 ? '-' . $rowObj->clInstNo : ''));
					$this->t->set_var('branch', $branch);
					$this->t->set_var('name', html_entities(truncateStr($clName)));
					$this->t->set_var('sType', $sType);
					$this->t->set_var('scType', $scName);
					$this->t->set_var('color', $color);
					$this->t->set_var('iName', $iName);
					$this->t->set_var('pName', $pName);
					$this->t->set_var('pAmt', $pAmt);
					$this->t->set_var('discount', $discount);
					$this->t->set_var('amtPaid', $amtPaid);
					$this->t->set_var('mode', $mode);
					$this->t->set_var('balance', $balance);
					$this->t->set_var('csStatus', $csStatus);
					$this->t->set_var('view', $htmlRemark);
					//$this->t->set_var('edit', $htmlEdit);
					$this->t->set_var('link', $linkRaNo);
					$this->t->set_var('bId', $rowObj->clReceiptIssuingBranchId);
					$this->t->set_var('ct', $rowObj->clCtTypeId);
					$this->t->set_var('st', $rowObj->clServTypeId);
					$this->t->set_var('sc', $rowObj->clServCountryId);

					$this->t->set_var('b', $rowObj->bName);
					$this->t->set_var('bs', $rowObj->bSid);
					$this->t->set_var('clType', $clType);
					$this->t->set_var('bc', $rowObj->bCid);
					$this->t->set_var('clType', $clType);

					$this->t->set_var('classCaseStatus', $classCaseStatus);

					$this->t->set_var('totalPaid', number_format($totalPaid));


					$this->t->set_var("bName", '<label class="pinkbox">' . $rowObj->bName . '</label>');

					$this->t->parse("record", "records", true);
					$i++;
				}
				$this->t->parse("norecords", "");
				if (($rowObj->clEmail == NULL) && ($qry == 0)) {
					$totalPaid = $rowObj->totalPaid;
					$totalBalance = $rowObj->totalBalance;
				}
			}
			//echo '<pre>';print_r($arrBalance);echo '</pre>';
			$totalBalance = 0;
			foreach ($arrBalance as $kRaNo => $vRaNo) {
				foreach ($vRaNo as $kClType => $vClType) {
					foreach ($vClType as $kClCtType => $vClCtType) {
						foreach ($vClCtType as $kSrCtType => $vSrCtType) {
							foreach ($vSrCtType as $kSrvType => $vSrvType) {
								foreach ($vSrvType as $kIssuingBr => $vIssuingBr) {
									$totalBalance += $this->calcBalance($kRaNo, $kClType, $kClCtType, $kSrCtType, $kSrvType, $kIssuingBr);
								}
							}
						}
					}
				}
			}
			$this->t->set_var('totalBalance', number_format($totalBalance));
			$this->t->set_var('p', urlencode($sqlSearch));
			$this->t->parse("recordMain", "recordsMain");
			$_SESSION['excel_p']=urlencode($sqlSearch); 
		} else {
			$this->t->parse("norecord", "norecords");
			$this->t->parse("recordsMain", " ");
		}
	}

	function calcBalance($find, $type, $cntType, $servCnt, $servType, $issuingBr) {
		switch ($type) {
			case 'New':
				$where = " clRetainerAggNo LIKE ";
				break;
			case 'Old':
				$where = " clOldRetainerAggNo LIKE ";
				break;
		}

		$condition = " AND clReceiptIssuingBranchId='" . $issuingBr . "' AND clCtTypeId = {$cntType} AND clServTypeId = {$servType} AND clServCountryId = {$servCnt}";
		$order = " ORDER BY clCreateDate DESC LIMIT 0,1";

		$sql = "SELECT pdBalance AS finalBalance FROM " . TABLECLIENT . " TC LEFT OUTER JOIN " . TABLEPAYDETAILS . " PD ON (TC.clId=PD.pdClId) WHERE " . $where . "'" . str_replace(" ", "", $find) . "'" . $condition . $order;

		$result = $this->con->execQry($sql);
		//echo $this->con->rowCount($result);
		if ($this->con->rowCount($result)) {
			$rowObj = $this->con->fetchObj($result);
			return $rowObj->finalBalance;
		}
		return 0;
	}

}

?>
