<?php

/*
 * ******************************************************************************
 * File name: class.newreceipt.php
 * Created on: 02/07/2008
 * ******************************************************************************
  -----------------
  -- Description --
  -----------------
  This file contains the class for newreceipt module.

  -----------------------------------------
  -- Major Revision/Modification History --
  -----------------------------------------
  Date     Programmer      Comments
  -------- --------------- ------------------------------------------------------
  07/07/2008	Anish Sharma	Started building the file.

 * ******************************************************************************
 *  Written By: Anish Sharma.
 * ******************************************************************************
 */

class newreceipt {

	var $rNo = '';
	var $orNo = '';
	var $raNo = '';
	var $cntType = '';
	var $stid = '';
	var $cid = '';
	var $fName = '';
	var $mName = '';
	var $lName = '';
	var $address = '';
	var $town = '';
	var $state = '';
	var $stateTxt = '';
	var $zip = '';
	var $country = '';
	var $resi = '';
	var $office = '';
	var $mob = '';
	var $email = '';
	var $instName = '';
	var $pPlan = '';
	var $pdTax = '';
	var $payAmt = '';
	var $discount = '';
	var $amtPayable = '';
	var $amtPaidOnDate = '';
	var $amtBalance = '';
	var $pMode = '';
	var $chqDD = '';
	var $chqDDdate = '';
	var $bank = '';
	var $remarks = '';
	var $advisor = '';
	var $refund = '';
	var $clId = '';
	var $currId = '';
	var $con;
	var $home1;
	var $t;
	var $action;
	var $isDuplicateClient = 0;
	var $isDuplicateRno;
	var $duplicateClId;
	var $pageName = 'newreceipt.php';

	/**
	 * This function will act as constructor.
	 * @param	string tplPath template path.
	 * @param	string maintpl main tpl file name.
	 * @param	string outerCenter outer center tpl file name.
	 * @param	string innerCenter inner tpl file name.
	 * @param	string headtpl header tpl file name.
	 * @param	string lefttpl left tpl file name.
	 * @param	string righttpl right tpl file name.
	 * @param	string footertpl footer tpl file name.
	 * @author	Anish Sharma
	 */
	function __construct($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl) {
		$this->home1 = new Home($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl);
		$this->home1->InitializeTemplates();
		$this->con = $this->home1->con;
		$this->action = (isset($_GET['action']) ? $_GET['action'] : '');
		$this->clId = ((isset($_GET['clId']) ? $_GET['clId'] : '0'));
		$this->clId = ((isset($_POST['clId']) ? $_POST['clId'] : $this->clId));
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				$this->{$key} = $value;
			}
		}
	}

	/**
	 * This function will main function used to asign template
	 * variable and call other functions.
	 * @author	Anish Sharma
	 */
	function create() {
		$this->t = &$this->home1->t;
		$this->parseBody();
		$this->home1->showInPage();
	}

	function assignPostValues() {
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				$this->t->set_var($key, $value);
			}
		}
	}

	/**
	 * This function will parse the body after creating it.
	 * @author	Anish Sharma
	 */
	function parseBody() {
		global $_CONF, $siteUrl, $siteUrlAjax;
		if (isset($_POST['subm']) && $_POST['subm'] == '1') {
			$this->addEditReceipt();
		}
		if (isset($_SESSION['msg'])) {
			$this->t->set_var('msg', $_SESSION['msg']);
			unset($_SESSION['msg']);
		}
		if ($_SESSION['session_countryId'] == '76') {
			$stateList = '<td height="23" align="left" id="tdState"><select name="state" id="state" class="form_field_text" style="width:298px">
				<option value="">-Select State-</option>' . statesList($_SESSION['session_countryId']) . '</select></td>
				<td align="left" id="tdStateText"><input type="text" name="stateTxt" id="stateTxt" class="form_filed_text" size="40"></td>
				';
		} else {
			$stateList = '<td height="23" align="left" id="tdState"><select name="state" id="state" class="form_field_text" style="width:298px;display:none;">
				<option value="">-Select State-</option>' . statesList($_SESSION['session_countryId']) . '</select></td>
				<td align="left" id="tdStateText"><input type="text" name="stateTxt" id="stateTxt" class="form_filed_text" size="40"></td>
				';
		}
		$currName = explode(',', getCurrCode($_SESSION['session_countryId']));
		$this->t->set_var('consultancyType', counsultancyTypeList());
		$this->t->set_var('ajaxSiteUrl', $siteUrlAjax);
		$this->t->set_var('branchId', $_SESSION['session_userId']);
		$this->t->set_var('currName', $currName[0]);
		$this->t->set_var('currId', $currName[1]);
		$this->t->set_var('menu', getMenuLinks($_SESSION['session_usertype']));
		$this->t->set_var('serviceType', serviceTypeList());
		$rNoArr = genReceiptNo();
		$this->t->set_var('rNo', $rNoArr[0]);
		$this->t->set_var('orNo', $rNoArr[1]);
		$this->t->set_var('country', countryList($_SESSION['session_countryId']));
		$this->t->set_var('stateList', $stateList);
		//$this->t->set_var('pPlan',paymentPlanByBranch($_SESSION['session_userId']));
		$this->t->set_var('bManager', getBranchManagerName($_SESSION['session_userId']));
		$this->t->set_var('pMode', paymentModeList());

		$this->t->parse('TPL_BODY', 'FORMPAGE');
	}

	function addEditReceipt() {
		global $siteUrl;
		$condition = '';
		$status = '';
		$OrgNo = '';
		$rNo = '';

		$sql = "SELECT clId FROM " . TABLECLIENT . " WHERE clFirstName = '" . $this->fName . "' AND clLastName = '" . $this->lName . "' AND clEmail= '" . $this->email . "'";
		$result = $this->con->execQry($sql);
		if ($this->con->rowCount($result)) {
			$rowObj = $this->con->fetchObj($result);
			$this->duplicateClId = $rowObj->clId;
			$this->isDuplicateClient = 1;
		}

		$sqlChck = "SELECT clFullReceiptNo FROM tbl_client WHERE clFullReceiptNo=" . $this->rNo;
		$resChck = $this->con->execQry($sqlChck);
		if ($this->con->rowCount($resChck)) {
			//$rowObj = $this->con->fetchObj($resChck);
			//$this->isDuplicateRno = 1;
			reDirect('index.php?errNo=1');
			exit;
		} else {
			$sqlChck = "SELECT clFullReceiptNo FROM tbl_client WHERE clFullReceiptNo=" . $this->rNo;
			$resChck = $this->con->execQry($sqlChck);
		}

		if ($this->isDuplicateRno == 1) {
			$_SESSION['msg'] = "The receipt number has already been assigned! New receipt NOT generated.";
			if (isset($_SESSION['msg']) && $_SESSION['msg'] != '') {
				$msgTr = '<tr>
					    <td colspan="2" align="center" class="highlightRed">{msg}</td>
					  </tr>';
				$this->t->set_var('msgTr', $msgTr);
			}
		}

		if ($this->isDuplicateClient == 1) {
			$_SESSION['msg'] = "Client named ({$this->fName} {$this->mName} {$this->lName}), having email id ($this->email) has already been registered! New receipt NOT generated.";
			if (isset($_SESSION['msg']) && $_SESSION['msg'] != '') {
				$msgTr = '<tr>
					    <td colspan="2" align="center" class="highlightRed">{msg}</td>
					  </tr>';
				$this->t->set_var('msgTr', $msgTr);
			}
		} else {
			/* $subject    = "{$this->rNo}";
			  $pattern    = strstr($subject, "".date('y')."");
			  $subPattern = substr($pattern, 2);
			  $fRno       = substr($subPattern, 0,1);
			  $sRno       = substr($subPattern, 0,2);

			  if($fRno =='0' && $sRno != '00'){
			  $OrgNo = substr($subPattern, 1);
			  }
			  if($fRno =='0' && $sRno == '00'){
			  $OrgNo = substr($subPattern, 2);
			  }
			  if($fRno !='0' && $sRno != '00'){
			  $OrgNo = $subPattern;
			  } */
			$OrgNo = $this->orNo;

			$dbState = ($this->state == '') ? $this->stateTxt : $this->state;
			$query = "INSERT INTO " . TABLECLIENT;
			$status = ", status = '1'";
			//$address = mysqli_escape_string($this->address);
			$address = $this->address;
			$query .= " SET clFirstName = '{$this->fName}', clMiddleName = '{$this->mName}', clLastName = '{$this->lName}', clAddr = '{$address}', clCity = '{$this->town}', clState = '{$dbState}', clZipCode = '{$this->zip}', clCountryId = '{$this->country}', clPhRes = '{$this->resi}', clPhWork = '{$this->office}', clPhMob = '{$this->mob}', clEmail = '{$this->email}', ";

			$query .= "clReceiptNo = '{$OrgNo}', clReceiptIssuingBranchId = '{$_SESSION['session_userId']}', clCtTypeId = '{$this->cntType}', clServTypeId ='{$this->stid}', clServCountryId ='{$this->cid}', clRetainerAggNo ='', clFullReceiptNo ='{$this->rNo}', clCreateDate=" . mysqli_now();

			$query .= $status;
			$query .= $condition;

			// $result = $this->con->execQry($query);
			// $insId = mysqli_insert_id

			// in mysqli add by kirti for above 2 lines
			$res = $this->con->lastidexecQry($query);
			$result =$res['result'];
			$insId = $res['last_id'];
			// end code by kirt
			genRaNo($this->stid, $this->cid, $insId);

			genInstNo($this->stid, $this->cid, $insId, $this->email, $this->fName . $this->mName . $this->lName);

			$qryPayDt = "INSERT INTO " . TABLEPAYDETAILS;
			$statusPayDt = ", status = '1'";
			
			$this->pdTax=$this->amtPaidOnDate-calculateTax($this->amtPaidOnDate);
			
			//$qryPayDt .= " SET pdClId = '{$insId}', pdInstNameId = '{$this->instName}', pdPid = '{$this->pPlan}', pdAmt = '{$this->payAmt}', pdDiscount = '{$this->discount}', pdTotalPayable = '{$this->amtPayable}', pdCurrId = '{$this->currId}', pdPaid = '{$this->amtPaidOnDate}', pdBalance = '{$this->amtBalance}', pdPayModeId = '{$this->pMode}', pdChqDDno = '{$this->chqDD}', pdChqDDdate = '{$this->chqDDdate}', pdChqDDbank = '{$this->bank}', ";
			$qryPayDt .= " SET pdClId = '{$insId}', pdInstNameId = '{$this->instName}', pdPid = '{$this->pPlan}', pdTax = '{$this->pdTax}', pdAmt = '{$this->payAmt}', pdDiscount = '{$this->discount}', pdTotalPayable = '{$this->amtPayable}', pdCurrId = '{$this->currId}', pdPaid = '{$this->amtPaidOnDate}', pdBalance = '{$this->amtBalance}', pdPayModeId = '{$this->pMode}', pdChqDDno = '{$this->chqDD}', pdChqDDdate = '{$this->chqDDdate}', pdChqDDbank = '{$this->bank}', ";
			
			//$remarks = mysqli_escape_string($this->remarks);
			$remarks = $this->remarks;
			$qryPayDt .= "pdIssuerRemark = '{$remarks}', pdIsRefundable = '{$this->refund}', pdAdvisorId ='{$this->advisor}', pdDate=" . mysqli_now();
			$resPayDt = $this->con->execQry($qryPayDt);

			if ($result && $resPayDt) {
				reDirect('index.php?ref=nr&clId=' . $insId);
				exit;
			}
			reDirect($this->pageName);
		}
		//$this->t->set_var('msg',$_SESSION['msg']);
	}

}

?>
