<?php
//ini_set("display_errors",1);
/* 
 * ******************************************************************************
 * File name: class.receipt.php
 * Created on: 02/07/2008
 * ******************************************************************************
  -----------------
  -- Description --
  -----------------
  This file contains the class for receipt module.

  -----------------------------------------
  -- Major Revision/Modification History --
  -----------------------------------------
  Date     Programmer      Comments
  -------- --------------- ------------------------------------------------------
  07/07/2008	Anish Sharma	Started building the file.

 * ******************************************************************************
 *  Written By: Anish Sharma.
 * ******************************************************************************
 */

class printout_gst {

	var $rNo = '';
	var $raNo = '';
	var $cntType = '';
	var $stid = '';
	var $cid = '';
	var $fName = '';
	var $mName = '';
	var $lName = '';
	var $address = '';
	var $town = '';
	var $state = '';
	var $zip = '';
	var $country = '';
	var $resi = '';
	var $office = '';
	var $mob = '';
	var $email = '';
	var $instName = '';
	var $pPlan = '';
	var $payAmt = '';
	var $discount = '';
	var $amtPayable = '';
	var $amtPaidOnDate = '';
	var $amtBalance = '';
	var $pMode = '';
	var $chqDD = '';
	var $chqDDdate = '';
	var $bank = '';
	var $remarks = '';
	var $advisor = '';
	var $refund = '';
	var $clId = '';
	var $currId = '';
	var $con;
	var $home1;
	var $t;
	var $action;
	var $isDuplicateClient = 0;
	var $duplicateClId;
	var $pageName = 'printout_gst.php';

	/**
	 * This function will act as constructor.
	 * @param	string tplPath template path.
	 * @param	string maintpl main tpl file name.
	 * @param	string outerCenter outer center tpl file name.
	 * @param	string innerCenter inner tpl file name.
	 * @param	string headtpl header tpl file name.
	 * @param	string lefttpl left tpl file name.
	 * @param	string righttpl right tpl file name.
	 * @param	string footertpl footer tpl file name.
	 * @author	Anish Sharma
	 */
	function __construct($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl) {
		$this->home1 = new Home($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl);
		$this->home1->InitializeTemplates();
		$this->con = $this->home1->con;
		$this->action = (isset($_GET['action']) ? $_GET['action'] : '');
		$this->clId = ((isset($_GET['clId']) ? $_GET['clId'] : '0'));
		$this->clId = ((isset($_POST['clId']) ? $_POST['clId'] : $this->clId));
	}

	/**
	 * This function will main function used to asign template
	 * variable and call other functions.
	 * @author	Anish Sharma
	 */
	function create() {
		$this->t = &$this->home1->t;
		$this->parseBody();
		$this->home1->showInPage();
	}

	/**
	 * This function will parse the body after creating it.
	 * @author	Anish Sharma
	 */
	function parseBody() {
		global $_CONF, $siteUrl, $siteUrlAjax;
		if (isset($_GET['clId']) && $_GET['clId'] != '' && is_numeric($_GET['clId'])) {
			/* echo '<pre>';
			  print_r($_POST);
			  die; */
			$id = $_GET['clId'];
			$this->fillData($id);
		}
		if (isset($_SESSION['msg'])) {
			$this->t->set_var('errormsg', $_SESSION['msg']);
			unset($_SESSION['msg']);
		}

		$this->t->parse('TPL_BODY', 'FORMPAGE');
	}

	function fillData($id) {
		global $siteUrl;
		//$sql = "SELECT *, DATE_FORMAT(clCreateDate,'%y') AS cdated FROM ".TABLECLIENT .' C ,'.TABLEPAYDETAILS." WHERE clId = ".$id." AND pdClId = ".$id." AND C.status = 1"; [COMMENTED ON 5th MAY 2010]
		$sql = "SELECT *, DATE_FORMAT(clCreateDate,'%y') AS cdated FROM " . TABLECLIENT . ' C ,' . TABLEPAYDETAILS . " WHERE clId = " . $id . " AND pdClId = " . $id . " AND C.status = 1";
		$result = $this->con->execQry($sql);
		if ($this->con->rowCount($result)) {
			while ($rowObj = $this->con->fetchObj($result)) { //echo "<pre>";print_r($rowObj);die;
				$pdamt = $rowObj->pdAmt;
				$date = $rowObj->clCreateDate;
				$currName = explode(',', getCurrCode($_SESSION['session_countryId']));
				$prefixCode = getStateCode($rowObj->clReceiptIssuingBranchId);

				//$clRcpNo   = $prefixCode.$rowObj->cdated.str_pad($rowObj->clReceiptNo, 3, "0", STR_PAD_LEFT); [COMMENTED ON 5th MAY 2010]
				if ($rowObj->clFullReceiptNo != '') {
					$clRcpNo = $rowObj->clFullReceiptNo;
				} else {
					$clRcpNo = $prefixCode . $rowObj->cdated . str_pad($rowObj->clReceiptNo, 3, "0", STR_PAD_LEFT); // [ADDED ON 5th MAY 2010]
				}
				//$clRcpNo = $rowObj->clFullReceiptNo;

				$clName = html_entities($rowObj->clFirstName) . '&nbsp;' . ($rowObj->clMiddleName ? html_entities($rowObj->clMiddleName) : '') . '&nbsp;' . html_entities($rowObj->clLastName);

				if ($rowObj->clRetainerAggNo != 0) {
					$prefixRaCode = getPreCodeForRaNo($rowObj->clServTypeId, $rowObj->clReceiptIssuingBranchId, $rowObj->clServCountryId) . getMonYrForRa($rowObj->clRetainerAggNo, $rowObj->clReceiptIssuingBranchId, $rowObj->clEmail);
					$clRaNo = $prefixRaCode . str_pad($rowObj->clRetainerAggNo, 4, "0", STR_PAD_LEFT);
				} else {
					$clRaNo = $rowObj->clOldRetainerAggNo;
				}

				$clAddr = html_entities($rowObj->clAddr);
				$clCity = html_entities($rowObj->clCity);
				$clinstno = html_entities($rowObj->clInstNo);

				if ($rowObj->clRetainerAggNo != 0) {
					$htmlInst = '<tr>
									<td height="22" class="padleft_10"><b><span class="float-left">Installment No</span><span class="float-right marginright_25">:</span></b></td>
									<td>' . $rowObj->clInstNo . '</td>
							</tr>';
				} else {
					$htmlInst = '<tr>
									<td height="22" class="padleft_10"><b><span class="float-left">Installment Name</span><span class="float-right marginright_25">:</span></b></td>
									<td>' . getInstallmentName($rowObj->pdInstNameId) . '</td>
							</tr>';
				}

				$clState = (is_numeric($rowObj->clState)) ? getStateName($rowObj->clState) : $rowObj->clState;
				;
				$clZip = html_entities($rowObj->clZipCode);
				$clEmail = $rowObj->clEmail;
				$pdTotalPayable = $rowObj->pdTotalPayable;
				$clSt = getServiceTypeName($rowObj->clServTypeId);
				$clServCountryId = getCountryName($rowObj->clServCountryId);
				$clCountry = getCountryName($rowObj->clCountryId);
				$clPh = ($rowObj->clPhRes ? $rowObj->clPhRes . '(R),&nbsp;' : '') . ($rowObj->clPhWork ? $rowObj->clPhWork . '(O),&nbsp;' : '') . ($rowObj->clPhMob ? $rowObj->clPhMob . '(M)&nbsp;' : '');

				$ctId = getConsultancyName($rowObj->clCtTypeId);
				if ($rowObj->clCtTypeId != '2') {
					if ($rowObj->clRetainerAggNo != 0) {
						$pPlan = '<tr>
								<td width="220" height="22" class="padleft_10">
									<b><span class="float-left">Payment Plan</span><span class="float-right marginright_25">:</span></b>
								</td>
								<td>' . ($rowObj->pdPid != 0 ? getPayPlanName($rowObj->pdPid) : '-') . '</td>
							</tr>';
					} else {
						$pPlan = '<tr>
								<td width="220" height="22" class="padleft_10">
									<b><span class="float-left">Payment Plan Amount</span><span class="float-right marginright_25">:</span></b>
								</td>
								<td>' . $rowObj->pdAmt . '&nbsp;' . $currName[0] . '</td>
							</tr>';
					}
				} else {
					$pPlan = '';
				}
				if (($rowObj->clCtTypeId == '2') && ($rowObj->pdIsRefundable)) {
					$refund = '<label class="red">(Refundable ONLY on VISA approval)<label>';
				} else {
					$refund = '';
				}

				if ($rowObj->clCtTypeId != '2') {
					/* $pdDiscount = '<tr>
								<td height="22" class="padleft_10"><b><span class="float-left">Discount</span><span class="float-right marginright_25">:</span></b></td>
								<td>' . $rowObj->pdDiscount . '&nbsp;' . $currName[0] . '</td>
							</tr>';*/
					$pdDiscount = $rowObj->pdDiscount;
					} else {
					$pdDiscount = '';
				}
			
				//$currname=$currName[0].' ';
				$clBrId = getBranchName($rowObj->clReceiptIssuingBranchId);
				$clBrGSTIN = getGSTIN($rowObj->clReceiptIssuingBranchId);
				$bManager = getBranchManagerName($rowObj->clReceiptIssuingBranchId);

				$pdPayModeId = getPayMode($rowObj->pdPayModeId);
				$pdPaid = $rowObj->pdPaid . '&nbsp;' . $currName[0];
				
				if($rowObj->pdTax!=0){
					$amt=$rowObj->pdPaid-$rowObj->pdTax;
					
					$amtServiceTax=$rowObj->pdTax; 
					$cgst=$amt * 9/100; 
					$sgst=$amt * 9/100;		
					$cgst=$amtServiceTax/2; 
					$sgst=$amtServiceTax/2;				
					
				}
				else{
					$amt=$rowObj->pdPaid;
					$amtServiceTax="-";
					//$cgst=$amt * 9/100; 
				//	$sgst=$amt * 9/100;	
					$cgst='-'; 
					$sgst='-';					

				}
				
					
					
				$pdBalance = $rowObj->pdBalance . '&nbsp;' . $currName[0];
				if ($rowObj->pdPayModeId == 1 || $rowObj->pdPayModeId == 2 || $rowObj->pdPayModeId == 7 || $rowObj->pdPayModeId == 9 || $rowObj->pdPayModeId == 10) {
					$html = '<tr>
							<td width="220" height="22" class="padleft_10"><b>DD/Cheque/Trans. Ref. No. :</b>' . $rowObj->pdChqDDno . '</td>
							<td>
								<span class="float-left" style="width:170px"><b>Dated:</b>' . $rowObj->pdChqDDdate . '</span>
								<span class="float-left"><b>Bank:</b>' . $rowObj->pdChqDDbank . '</span>
							</td>
							</tr>';
				} else {
					$html = '';
				}

				if ($rowObj->clCaseStatus == 2) {
					$trCancelled = '<tr align="center">
						<td colspan="2"><img src="images/cancelled_stamp.jpg"></td>
					</tr>';
				} else {
					$trCancelled = '';
				}

				$this->t->set_var('trCancelled', $trCancelled);
				$this->t->set_var('date', $date);
				$this->t->set_var('ctId', $ctId);
				$this->t->set_var('clName', $clName);
				$this->t->set_var('raNo', $clRaNo);
				$this->t->set_var('rNo', $clRcpNo);
				$this->t->set_var('address', $clAddr);
				$this->t->set_var('city', $clCity);
				$this->t->set_var('state', $clState);
				$this->t->set_var('zip', $clZip);
				$this->t->set_var('country', $clCountry);
				$this->t->set_var('phone', $clPh);
				$this->t->set_var('email', $clEmail);
				$this->t->set_var('stId', $clSt);
				$this->t->set_var('srvCountry', $clServCountryId);
				$this->t->set_var('pPlan', $pPlan);

				$this->t->set_var('amt',$currname. $amt);
				$this->t->set_var('amtServiceTax',$currname. $amtServiceTax);
				$this->t->set_var('amtPaid', $currname. $pdPaid);
				// echo $pdamt;die;
				$this->t->set_var('pdamt', $currname. $pdamt);
				$this->t->set_var('discountDetails', $currname. $pdDiscount);
				$this->t->set_var('pMode', $pdPayModeId);
				$this->t->set_var('pBal', $currname. $pdBalance);
				$this->t->set_var('bManager', $bManager);
				$this->t->set_var('installmentCond', $htmlInst);
				//$this->t->set_var('chqBank',$pdChqBank);
				$this->t->set_var('payDetails', $html);
				$this->t->set_var('refund', $refund);
				$this->t->set_var('brId', $clBrId);
				$this->t->set_var('HEAD_OFFICE_ADDRESS', HEAD_OFFICE_ADDRESS);
				$this->t->set_var('totalPayable', $currname.$pdTotalPayable);//echo $pdTotalPayable;
				$this->t->set_var('cgstpercent', '9%');
				$this->t->set_var('sgstpercent', '9%');
				$this->t->set_var('cgst', $currname. $cgst);
				$this->t->set_var('sgst', $currname. $sgst);
				$gtotal= ceil($amt+$cgst+$sgst);  //rounds a number UP to the nearest integer
				$this->t->set_var('gtotal', $currname. $gtotal);
				$this->t->set_var('clinstno', $clinstno);
				$this->t->set_var('clbrGSTIN', $clBrGSTIN);
				$this->clientqr_create($clName);
	
				
			}
		}
	}

	function clientqr_create($clName) {

			try {

					// set BarcodeQR object
					//$qr = new BarcodeQR();

					$virtualUrl="receipt.itcallers.com";

					// create URL QR code
					$url="https://chart.googleapis.com/chart?chs=300x300&cht=qr&chl=http%3A%2F%2F".$virtualUrl.$_SERVER['REQUEST_URI'].'&choe=UTF-8';

					// display new QR code image
					//$clientqr=$qr->draw();

					$clientqr = '<img src="' . $url . '" alt="QR Code" width="75"/>'; // Generate and display the QR Code
					$this->t->set_var('clientqr', $clientqr);

			} catch (Exception $oExcept) {
			    echo '<p><b>Exception launched!</b><br /><br />' .
			        'Message: ' . $oExcept->getMessage() . '<br />' .
			        'File: ' . $oExcept->getFile() . '<br />' .
			        'Line: ' . $oExcept->getLine() . '<br />' .
			        'Trace: <p/><pre>' . $oExcept->getTraceAsString() . '</pre>';
			}


	}

}



?>
