<?php

/*
 * ******************************************************************************
 * File name: class.remarks.php
 * Created on: 12/08/2008
 * ******************************************************************************
  -----------------
  -- Description --
  -----------------
  This file contains the class for remarks module.

  -----------------------------------------
  -- Major Revision/Modification History --
  -----------------------------------------
  Date     Programmer      Comments
  -------- --------------- ------------------------------------------------------
  07/07/2008	Anish Sharma	Started building the file.

 * ******************************************************************************
 *  Written By: Anish Sharma. 
 * ******************************************************************************
 */

class remarks {

	var $con;
	var $home1;
	var $t;
	var $action;

	/**
	 * This function will act as constructor.
	 * @param	string tplPath template path.
	 * @param	string maintpl main tpl file name.
	 * @param	string outerCenter outer center tpl file name.
	 * @param	string innerCenter inner tpl file name.
	 * @param	string headtpl header tpl file name.
	 * @param	string lefttpl left tpl file name.
	 * @param	string righttpl right tpl file name.
	 * @param	string footertpl footer tpl file name.
	 * @author	Anish Sharma
	 */
	function __construct($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl) {
		$this->home1 = new Home($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl);
		$this->home1->InitializeTemplates();
		$this->con = $this->home1->con;
		$this->action = (isset($_GET['action']) ? $_GET['action'] : '');
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				$this->{$key} = $value;
			}
		}
	}

	/**
	 * This function will main function used to asign template
	 * variable and call other functions.
	 * @author	Anish Sharma
	 */
	function create() {
		$this->t = &$this->home1->t;
		$this->parseBody();
		$this->home1->showInPage();
	}

	function assignPostValues() {
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				return $this->t->set_var($key, $value);
			}
		}
	}

	/**
	 * This function will parse the body after creating it.
	 * @author	Anish Sharma
	 */
	function parseBody() {
		global $_CONF, $siteUrl, $siteUrlAjax;

		if (isset($_GET['rm'])) {
			$this->getRemarks($_GET['rm']);
		}

		$this->t->parse('TPL_BODY', 'FORMPAGE');
	}

	function getRemarks($id) {
		global $siteUrl;
		$condition = '';
		$status = '';

		$sqlRemarks = " SELECT pdIssuerRemark FROM " . TABLEPAYDETAILS . " WHERE pdClId = {$id}";

		$resRemarks = $this->con->execQry($sqlRemarks);
		$numOfRows = $this->con->rowCount($resRemarks);

		if ($numOfRows != 0) {
			$rowObj = $this->con->fetchObj($resRemarks);
			$this->t->set_var('remarks', html_entities($rowObj->pdIssuerRemark));
		} /* else {
		  $this->t->set_var('remarks','-- No remarks given--');
		  } */
	}

}

?>