<?php

/*
 * ******************************************************************************
 * File name: class.searchclient.php
 * Created on: 29/07/2008
 * ******************************************************************************
  -----------------
  -- Description --
  -----------------
  This file contains the class for search client module.

  -----------------------------------------
  -- Major Revision/Modification History --
  -----------------------------------------
  Date     Programmer      Comments
  -------- --------------- ------------------------------------------------------
  29/07/2008	Anish Sharma	Started building the file.

 * ******************************************************************************
 *  Written By: Anish Sharma.
 *
 * ******************************************************************************
 */

class searchclient {

	var $sMode;
	var $t;
	var $home1;
	var $con;
	var $remarks = '';
	var $refund = '';
	var $approvBy = '';
	var $reqAct = '';
	var $pageName = "clsearch.php";

	/**
	 * This function will act as constructor .
	 * @param	string tplPath template path.
	 * @param	string maintpl main tpl file name.
	 * @param	string outerCenter outer center tpl file name.
	 * @param	string innerCenter inner tpl file name.
	 * @param	string headtpl header tpl file name.
	 * @param	string lefttpl left tpl file name.
	 * @param	string righttpl right tpl file name.
	 * @param	string footertpl footer tpl file name.
	 * @author
	 */
	function __construct($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl) {
		$this->home1 = new Home($tplPath, $maintpl, $innerCenter, $headtpl, $lefttpl, $footertpl);
		$this->home1->InitializeTemplates();
		$this->con = $this->home1->con;
		foreach ($_POST as $key => $value) {
			if (isset($this->{$key})) {
				$this->{$key} = $value;
			}
		}
	}

	/**
	 * This function will main function used to asign tamplate
	 * variable and call other functions.
	 * @author Anish Sharma
	 */
	function create() {
		$this->t = &$this->home1->t;
		$this->parseBody();
		$this->home1->showInPage();
	}

	/**
	 * This function will parse the body after creating it
	 * @author Anish Sharma
	 */
	function parseBody() {
		global $_CONF, $siteUrl, $siteUrlAjax;

		if (isset($_POST['search']) && $_POST['search'] == 1) {
			$this->search($_POST['r'], $_POST['clType'], $_POST['cntType'], $_POST['sc'], $_POST['stid'], $_POST['br']);
		}

		if (isset($_POST['subm']) && $_POST['subm'] == 1) {
			$this->saveData($_POST['raNo'], $_POST['clName'], $_POST['clEmail'], $_POST['brId']);
		}

		if (isset($_SESSION['msg'])) {
			$this->t->set_var('msg', $_SESSION['msg']);
			unset($_SESSION['msg']);
		}

		$this->t->set_var('reqAction', caseStatusList('', '', '', true));
		$this->t->parse('TPL_BODY', 'FORMPAGE');
		$this->t->set_var('ajaxSiteUrl', $siteUrlAjax);
		$this->t->set_var('branchId', $_SESSION['session_userId']);
	}

	function search($ra, $type, $ct, $sc, $st, $br) {
		global $siteUrl;
		$condition = '';
		$where = '';
		$status = '';
		$order = '';
		$cond = '';

		$sqlUsr = "SELECT bUserTypeId AS id FROM " . TABLEBRANCH . " WHERE bId = " . $_SESSION['session_userId'];
		$resUsr = $this->con->execQry($sqlUsr);
		$rowUsr = $this->con->fetchObj($resUsr);


		switch ($type) {
			case 'new':
				//$where = " clRetainerAggNo LIKE ";
				$where = " clRetainerAggNo = ";
				break;
			case 'old':
				$where = " clOldRetainerAggNo LIKE ";
				break;
		}

		$condition = "  AND clCtTypeId = {$ct} AND clServTypeId = {$st} AND clServCountryId = {$sc}";
		if ($_SERVER['REMOTE_ADDR'] != '122.180.41.73' && $_SERVER['REMOTE_ADDR'] != '10.0.0.92') {
			$condition.=" AND clReceiptIssuingBranchId={$br}";
		}
		$order = " ORDER BY clCreateDate DESC LIMIT 0,1";

		$sql = "SELECT *,bName,bSid,bCid FROM " . TABLECLIENT . " TC LEFT OUTER JOIN " . TABLEPAYDETAILS . " PD ON (TC.clId=PD.pdClId) LEFT OUTER JOIN " . TABLEBRANCH . " B	ON (TC.clReceiptIssuingBranchId=B.bId) WHERE " . $where . "'" . str_replace(" ", "", $ra) . "'" . $condition . $order;
		$ra = str_replace(" ", "", $ra);
		$ra = str_pad($ra, 4, "0", STR_PAD_LEFT);
		$result = $this->con->execQry($sql);

		if ($this->con->rowCount($result)) {
			$rowObj = $this->con->fetchObj($result);

			$fName = $rowObj->clFirstName;
			$mName = ($rowObj->clMiddleName ? $rowObj->clMiddleName : '');
			$lName = $rowObj->clLastName;
			$clName = $fName . '&nbsp;' . $mName . '&nbsp;' . $lName;

			if ($rowObj->clRetainerAggNo == 0) {
				$linkRaNo = $rowObj->clOldRetainerAggNo;
				$raNo = $rowObj->clOldRetainerAggNo;
				$clType = 'Old';
			} else {
				$prefixRaCode = getPreCodeForRaNo($rowObj->clServTypeId, $rowObj->clReceiptIssuingBranchId, $rowObj->clServCountryId) . getMonYrForRa($rowObj->clRetainerAggNo, $rowObj->clReceiptIssuingBranchId, $rowObj->clEmail);
				$raNo = $prefixRaCode . str_pad($rowObj->clRetainerAggNo, 4, "0", STR_PAD_LEFT);
				$linkRaNo = $rowObj->clRetainerAggNo;
				$clType = 'New';
			}

// only for accounts & admin : start

			if ($rowUsr->id != 2) {
				$condition = " ";
				$html = '
					<tr class="darkCell">
						<td class="padright_10 rightborder" align="right"><b>Action Required :</b></td>
						<td class="padleft_5">
							<select name="reqAct" id="reqAct" class="form_field_text">
							  <option value="">-Select Action Required-</option>
							  {reqAction}
							</select>&nbsp;<label id="errSr" class="highlightRed" style="display:none">please select the action required</label>
						</td>
					  </tr>
					</table></td>
				  </tr>
				  <tr>
					<td>
						<table width="100%" border="0" cellspacing="0" cellpadding="0" id="bottomTb">
						  <tr class="darkCell">
							<td width="246" class="cnt_header">&nbsp;</td>
							<td class="cnt_header">&nbsp;</td>
						  </tr>
						  <tr class="lightcell">
							<td width="246" class="padright_10 rightborder" align="right"><b><label id="dynamicText">Enter Remarks</label> :*</b></td>
							<td class="padleft_5"><input name="remarks" type="text" id="remarks" size="67" class="form_field_text" /></td>
						  </tr>
						  <tr class="darkCell" id="underRemarks">
							<td colspan="2">
								<table width="100%" border="0" cellspacing="0" cellpadding="0">
								  <tr class="darkCell">
									<td width="250" class="padright_10 rightborder" align="right"><b>Refund (If any) :</b></td>
									<td class="padleft_5"><input type="text" name="refund" id="refund" class="form_field_text" /></td>
								  </tr>
								  <tr  class="lightcell">
									<td width="250" class="padright_10 rightborder" align="right"><b>Refund Approved by :</b></td>
									<td class="padleft_5">
										<table border="0" cellpadding="0" cellspacing="0">
										  <tr>
											<td width="145"><input type="text" name="approvBy" id="approvBy" class="form_field_text" /></td>
										  </tr>
										</table>
									</td>
								  </tr>
								</table>
							</td>
						  </tr>
						  <tr class="cnt_footer">
							<td width="246" class="padleft_10">&nbsp;</td>
							<td class="padleft_5">
								<input type="hidden" value="1" name="subm">
								<input type="hidden" value="' . $rowObj->clId . '" name="clId">
								<input type="hidden" value="' . $fName . $mName . $lName . '" name="clName">
								<input type="hidden" value="' . $rowObj->clEmail . '" name="clEmail">
								<input type="hidden" value="' . $rowObj->clReceiptIssuingBranchId . '" name="brId">
								<input type="hidden" value="' . $linkRaNo . '" name="raNo">
								<input name="submit" type="button" class="btn" id="submit" value="Submit" border="0" width="111" height="29">
							</td>
						  </tr>
						</table>
					</td>
				  </tr>
			';
			} else {
				$html = '';
			}



// only for accounts & admin : end
			if ($rowObj->pdPid != 0) {
				$pPlan = '<tr class="lightcell">
				<td width="250" class="padright_10 rightborder" align="right"><b>Payment Plan :</b></td>
				<td class="padleft_5">' . getPayPlanName($rowObj->pdPid) . '</td>
				</tr>';
			} else {
				$pPlan = '';
			}
			$clSt = getServiceTypeName($rowObj->clServTypeId);

			//$pPlan = $rowObj->pdPid;

			$currName = explode(',', getCurrCode($_SESSION['session_countryId']));

			$this->t->set_var('link', $linkRaNo);
			$this->t->set_var('bId', $rowObj->clReceiptIssuingBranchId);
			$this->t->set_var('ct', $rowObj->clCtTypeId);
			$this->t->set_var('st', $rowObj->clServTypeId);
			$this->t->set_var('sc', $rowObj->clServCountryId);
			$this->t->set_var('clType', $clType);
			$this->t->set_var('clId', $rowObj->clId);

			$this->t->set_var('b', $rowObj->bName);
			$this->t->set_var('bs', $rowObj->bSid);
			$this->t->set_var('bc', $rowObj->bCid);


			$this->t->set_var('html', $html);
			$this->t->set_var('raNo', $raNo);
			$this->t->set_var('clId', $rowObj->pdClId);
			$this->t->set_var('name', $clName);
			$this->t->set_var('branch', getBranchName($rowObj->clReceiptIssuingBranchId));

			$this->t->set_var('caseStatus', getCaseStatusName($rowObj->clCaseStatus));
			$this->t->set_var('stId', $clSt);
			$this->t->set_var('srvCountry', getCountryName($rowObj->clServCountryId));
			$this->t->set_var('pPlan', $pPlan);
			$this->t->set_var('balance', $currName[0] . '&nbsp;' . $rowObj->pdBalance);
			$url = '<input type="hidden" value="' . $siteUrl . 'changepaymentplan.php?clId=' . $rowObj->pdClId . '" name="planUrl" id="planUrl">';
			$amountUrl = '<input type="hidden" value="' . $siteUrl . 'changeamount.php?clId=' . $rowObj->pdClId . '" name="amountUrl" id="amountUrl">';
			$this->t->set_var('planUrl', $url);
			if ($_SERVER['REMOTE_ADDR'] == '122.180.41.73' || $_SERVER['REMOTE_ADDR'] == '10.0.0.92') {
				//$this->t->set_var('updateplan', $siteUrl . 'newreceipt.php?editid=' . $rowObj->pdClId);
				//  $this->t->set_var('updateplan', $siteUrl . 'changepaymentplan.php?clId=' . $rowObj->pdClId);
				// $this->t->set_var('changeamount', $siteUrl . 'changeamount.php?clId=' . $rowObj->pdClId);
				$this->t->set_var('updateplan', $siteUrl . 'editclientprofile.php?clId=' . $rowObj->pdClId);
				$this->t->set_var('changeamount', '#');
			} else {
				$this->t->set_var('updateplan', $siteUrl . 'editclientprofile.php?clId=' . $rowObj->pdClId);
				$this->t->set_var('changeamount', '#');
			}
			$this->t->set_var('amountUrl', $amountUrl);
		} else {
			echo '<center><ul class="highlightRed"><li>no match for the chosen combination found in the database!</li></ul></center>';
			exit;
		}
	}

	function saveData($raNO, $clN, $clE, $bId) {
		global $siteUrl;
		$condition = '';
		$status = '';
		$arrId = array();

		$sqlId = " SELECT clId
				FROM " . TABLECLIENT . "
				WHERE (clRetainerAggNo = '{$raNO}' OR clOldRetainerAggNo = '{$raNO}')
				AND clReceiptIssuingBranchId = {$bId}
				AND CONCAT(clFirstName,clMiddleName,clLastName) = '{$clN}'
				AND clEmail = '{$clE}' ";
		$resId = $this->con->execQry($sqlId);

		if ($this->con->rowCount($resId)) {
			while ($rowObjId = $this->con->fetchObj($resId)) {
				$arrId[] = $rowObjId->clId;
			}
		}
		$valId = implode(',', $arrId);

		$qryPayDt = "UPDATE " . TABLEPAYDETAILS;
		$qryPayDt .= " SET pdRefundRemarks = '{$this->remarks}', pdRefundDate = NOW(), pdRefundAmt =  '{$this->refund}', pdRefundApprovBy = '{$this->approvBy}'";
		$qryPayDt .= " WHERE pdClId IN ({$valId}) ";
		$resPayDt = $this->con->execQry($qryPayDt);

		$qryCl = "UPDATE " . TABLECLIENT;
		$qryCl .= " SET clCaseStatus = {$this->reqAct}";
		$qryCl .= " , clCaseDate = NOW()";
		$qryCl .= " WHERE clId IN ({$valId}) ";
		$resQryCl = $this->con->execQry($qryCl);

		if ($resPayDt && $resQryCl) {
			reDirect($this->pageName . '?pc=cp');
		} else {
			reDirect($this->pageName);
		}
	}

}

?>
